{$n+,e+}

program wastedtop_v10;

uses crt,struc102,dos;

type infokey = record
       recnum  : longint;
       uplbyte : double;
     end;
     toplisttype = ^toplistnode;
     toplistnode = record
       info    : infokey;
       next    : toplisttype;
     end;

var  toplist : toplisttype;
     userfilename : string;
     nodenum : string;
     userfile : file of userrecord;
     user : userrecord;
     toprec : infokey;
     outfile,headerfile : text;
     topnum,toptotal : word;
     code : integer;
     tmpline : string;
     t_ul,t_dl,t_call,t_mesg : double;

procedure getuplfile(nodenum : string;var filename  : string);
var configfile : file of configrec;
    config : configrec;
begin
  assign(configfile,getenv('System')+'\config.'+nodenum);
  reset(configfile);
  read(configfile,config);
  filename := config.data+'\users.dat';
  close(configfile);
end;

procedure makelist(var list : toplisttype);
begin
  list := nil;
end;

procedure putsort(var list : toplisttype;elem : infokey);
var tmp1,tmp2,tmp3 : toplisttype;
begin
  tmp3 := list;
  new(tmp1);
  tmp1^.info := elem;
  if list = nil then begin
    tmp1^.next := list;
    list := tmp1;
  end else begin
    if elem.uplbyte >= list^.info.uplbyte then begin
      tmp1^.next := list;
      list := tmp1;
    end else begin
      tmp2 := list;
      while (list^.info.uplbyte > elem.uplbyte) and (list <> nil) do begin
        tmp2 := list;
        list := list^.next;
      end;
      tmp2^.next := tmp1;
      tmp1^.next := list;
      list := tmp3;
    end;
  end;
end;

procedure fetchlist(var list : toplisttype;var elem : infokey);
var tmp1 : toplisttype;
begin
  if list <> nil then begin
    tmp1 := list;
    list := list^.next;
    elem := tmp1^.info;
    dispose(tmp1);
  end;
end;

procedure closelist(var list : toplisttype);
var tmp : toplisttype;
begin
  while list <> nil do begin
    tmp := list;
    list := list^.next;
    dispose(tmp);
  end;
end;

function LeadingZero(w : Word) : String;
var
  s : String;
begin
  Str(w:0,s);
  if Length(s) = 1 then
    s := '0' + s;
  LeadingZero := s;
end;

function txtfelt(indoub : double;strlen : integer) : string;
var tmpstr1,tmpstr : string;
    tmpint : integer;
begin
  str(indoub:0:0,tmpstr1);
  case length(tmpstr1) of
    0..3 : tmpstr := tmpstr1;
    4..6 : tmpstr := copy(tmpstr1,1,length(tmpstr1)-3)+','+copy(tmpstr1,length(tmpstr1)-2,3);
    7..9 : tmpstr := copy(tmpstr1,1,length(tmpstr1)-6)+','+copy(tmpstr1,length(tmpstr1)-5,3)+','
                     +copy(tmpstr1,length(tmpstr1)-2,3);
  10..12 : tmpstr := copy(tmpstr1,1,length(tmpstr1)-9)+','+copy(tmpstr1,length(tmpstr1)-8,3)+','
                     +copy(tmpstr1,length(tmpstr1)-5,3)+','+copy(tmpstr1,length(tmpstr1)-2,3);
  end;
  for tmpint := length(tmpstr) to strlen do
    tmpstr := ' '+tmpstr;
  txtfelt := tmpstr;
end;

function udfelt(instr : string;strlen : byte):string;
var i : byte;
    tmpstr : string;
begin
  tmpstr := '';
  if length(instr) = strlen then
    udfelt := instr;
  if length(instr) > strlen then begin
    udfelt := copy(instr,1,strlen);
  end;
  if length(instr) < strlen then begin
    tmpstr := instr;
    for i := length(instr) to strlen-1 do
      tmpstr := tmpstr + ' ';
    udfelt := tmpstr;
  end;
end;

begin

  writeln('       __             _');
  writeln(' .--> _\__ ___ ___ ___/       .---------------.         .--------------------.');
  writeln(' `-.  \ . /__//__//__/ ----.  | wASTEDtOP v1.0 (c) cyberkid/fOOD 1996. >-----''');
  writeln('   `----''                  `--''               `---------''');

  t_ul := 0; t_dl := 0; t_call := 0; t_mesg := 0;
  val(paramstr(2),toptotal,code);
  if paramcount <> 4 then begin
    writeln(' -.  .-.');
    writeln('  `--'' `-> Syntax - WastdTop.Exe <Node> <Num_On_Bull> <U|D> <Outfile>');
  end else begin
    nodenum := paramstr(1);
    getuplfile(nodenum,userfilename);
    assign(userfile,userfilename);
    {$i-}
    reset(userfile);
    {$i+}
    if ioresult <> 0 then begin
      writeln('Error! Users.Dat doesn''t seem to be available!');
      halt(1);
    end;
    makelist(toplist);
    while not eof(userfile) do begin
      toprec.recnum := filepos(userfile);
      read(userfile,user);
      t_ul := t_ul + user.upk;
      t_dl := t_dl + user.downk;
      t_mesg := t_mesg + user.msgposted;
      t_call := t_call + user.callstotal;
      if (paramstr(3) = 'U') or (paramstr(3) = 'u')  then
        toprec.uplbyte := user.upk
      else
        toprec.uplbyte := user.downk;
      putsort(toplist,toprec);
    end;
    assign(outfile,paramstr(4));
    rewrite(outfile);

    writeln(outfile,'@X07');
    writeln(outfile,'@X0F  @X07.  __@X03_@X07_@X03____________ __ _@X02@X65T@X56h@X65e',
                    ' TOP ',toptotal:2,' Be@X56st Uploader@X65s@X56!@X02@X03_ __ _______________  @X07.');
    writeln(outfile,'@X07 _@X03|__\                                                    ',
                    '               @X01/@X03__@X01|@X03_');
    writeln(outfile,'@X03  |     @X07U@X06s@X05ername@X06.....   @X07L@X06o@X05cation@X06...........',
                    '   @X07U@X06L @X05Bytes@X06.....   @X07D@X06L @X05Bytes@X06..... @X01|');
    writeln(outfile,'@X07 -@X03|--------------------------------------------------------------------',
                    '-----@X01|@X03-');

    while (topnum < toptotal) and (toplist <> nil) do begin
      inc(topnum);
      fetchlist(toplist,toprec);
      seek(userfile,toprec.recnum);
      read(userfile,user);
      write(outfile,'@X03  |@X07 ',topnum:2,'@X05. @X07');
      if (paramstr(3) = 'U') or (paramstr(3) = 'u')  then begin
        write(outfile,udfelt(user.name,14),'  ',udfelt(user.location,19),
                      txtfelt(user.upk,15),txtfelt(user.downk,15),' ');
      end else begin
        write(outfile,udfelt(user.name,14),'  ',udfelt(user.location,19),
                      txtfelt(user.downk,15),txtfelt(user.upk,15),' ');
      end;
      writeln(outfile,'@X01|');
    end;

    writeln(outfile,' @X07-@X03|@X07--@X03-@X07-@X03----@X01-@X03---@X01-@X03--@X01-@X03-@X01',
                    '--------------------------------------------------------|-');

    writeln(outfile,'  @X03|   @X07Total Ul.Bytes@X05: @X06[@X07',txtfelt(t_ul,14),
                    '@X06]   @X07Total Dl.Bytes@X05: @X06[@X07',txtfelt(t_dl,14),'@X06].@X01|');
    writeln(outfile,' @X06_@X03|@X06____  @X07Total Calls@X05: @X06[@X07',txtfelt(t_call,14),
                    '@X06]   @X07Total Messages@X05: @X06[@X07',txtfelt(t_mesg,14),'@X06]!@X01|');
    writeln(outfile,' @X07_@X03|__ @X06/__ _                                                ',
                    '               @X07_@X03_@X01|@X03_');
    writeln(outfile,'  ! /@X01_____ _ @X05wASTEDtOP v1.0 @X06 @X011996 CYBERKID/FOOD @X07- ',
                    '@X06Design by Newt! @X01_ _____@X03\ @X01!');

    writeln(outfile,'');
    closelist(toplist);
    close(outfile);
    close(userfile);
    writeln('  .-.---> Created ',paramstr(4),' successfully.');
    writeln(' -'' `-''');
  end;
end.
